FROM docker.io/jupyter/datascience-notebook:2022-10-09

LABEL name="jupyterlab" \
    maintainer="Jooa <git@jooa.xyz>" \
    description="A pre-configured R/Julia/Python Jupyter container with LSP support" \
    version="0.2"

# Install jupyterlabextensions
RUN mamba install --yes -c conda-forge jupyterlab-lsp jupyterlab_vim "jupyterlab_execute_time==2.3.1" jupyterlab-unfold

# Install Language Servers
RUN set -eux; \
    mamba install --yes -c conda-forge r-languageserver; \
    npm install --no-save pyright; \
    julia -e "using Pkg; Pkg.add(\"LanguageServer\"); Pkg.precompile()"

# Add some julia packages
RUN julia -e "using Pkg; Pkg.add([\"CSV\", \"DataFrames\", \"DataFramesMeta\", \"Plots\", \"PyPlot\", \"StatsPlots\"])"
RUN julia -e "using Pkg; Pkg.update(); Pkg.gc(); Pkg.precompile()"

# Override some settings
ADD overrides.json /opt/conda/share/jupyter/lab/settings/overrides.json
ADD julials.json /opt/conda/etc/jupyter/jupyter_server_config.d/julia-ls.json

# Cleanup
USER root
RUN set -eux; \
    mamba clean --all -f -y; \
    fix-permissions $CONDA_DIR; \
    fix-permissions /home/$NB_USER
USER ${NB_USER}

LABEL run="podman run --rm -it --security-opt label=disable --log-driver=none -v \"\${PWD}\":/home/jovyan/work -p 8888:8888 --userns=keep-id:uid=1000,gid=100 \$IMAGE start-notebook.sh --notebook-dir=work"
